
local C = require("classic")


-- Graphics

g_livarm1n            = kts.Graphic("gfx/livarm1n.bmp", 255,255,0)
g_livarm1e            = kts.Graphic("gfx/livarm1e.bmp", 255,255,0)
g_livarm1s            = kts.Graphic("gfx/livarm1s.bmp", 255,255,0)
g_livarm1w            = kts.Graphic("gfx/livarm1w.bmp", 255,255,0)
g_livarm2n            = kts.Graphic("gfx/livarm2n.bmp", 255,255,0)
g_livarm2e            = kts.Graphic("gfx/livarm2e.bmp", 255,255,0)
g_livarm2s            = kts.Graphic("gfx/livarm2s.bmp", 255,255,0)
g_livarm2w            = kts.Graphic("gfx/livarm2w.bmp", 255,255,0)
g_livarm3n            = kts.Graphic("gfx/livarm3n.bmp", 255,255,0)
g_livarm3e            = kts.Graphic("gfx/livarm3e.bmp", 255,255,0)
g_livarm3s            = kts.Graphic("gfx/livarm3s.bmp", 255,255,0)
g_livarm3w            = kts.Graphic("gfx/livarm3w.bmp", 255,255,0)
g_livarm4n            = kts.Graphic("gfx/livarm4n.bmp", 255,255,0)
g_livarm4e            = kts.Graphic("gfx/livarm4e.bmp", 255,255,0)
g_livarm4s            = kts.Graphic("gfx/livarm4s.bmp", 255,255,0)
g_livarm4w            = kts.Graphic("gfx/livarm4w.bmp", 255,255,0)
g_livarm5n            = kts.Graphic("gfx/livarm5n.bmp", 255,255,0)
g_livarm5e            = kts.Graphic("gfx/livarm5e.bmp", 255,255,0)
g_livarm5s            = kts.Graphic("gfx/livarm5s.bmp", 255,255,0)
g_livarm5w            = kts.Graphic("gfx/livarm5w.bmp", 255,255,0)
g_livarm6n            = kts.Graphic("gfx/livarm6n.bmp", 255,255,0)
g_livarm6e            = kts.Graphic("gfx/livarm6e.bmp", 255,255,0)
g_livarm6s            = kts.Graphic("gfx/livarm6s.bmp", 255,255,0)
g_livarm6w            = kts.Graphic("gfx/livarm6w.bmp", 255,255,0)
g_livarm7n            = kts.Graphic("gfx/livarm7n.bmp", 255,255,0)
g_livarm7e            = kts.Graphic("gfx/livarm7e.bmp", 255,255,0)
g_livarm7s            = kts.Graphic("gfx/livarm7s.bmp", 255,255,0)
g_livarm7w            = kts.Graphic("gfx/livarm7w.bmp", 255,255,0)
g_livarm8n            = kts.Graphic("gfx/livarm8n.bmp", 255,255,0)
g_livarm8e            = kts.Graphic("gfx/livarm8e.bmp", 255,255,0)
g_livarm8s            = kts.Graphic("gfx/livarm8s.bmp", 255,255,0)
g_livarm8w            = kts.Graphic("gfx/livarm8w.bmp", 255,255,0)

g_livarm_p1n            = kts.Graphic("gfx/livarm_p1n.bmp", 255,255,0)
g_livarm_p1e            = kts.Graphic("gfx/livarm_p1e.bmp", 255,255,0)
g_livarm_p1s            = kts.Graphic("gfx/livarm_p1s.bmp", 255,255,0)
g_livarm_p1w            = kts.Graphic("gfx/livarm_p1w.bmp", 255,255,0)
g_livarm_p2n            = kts.Graphic("gfx/livarm_p2n.bmp", 255,255,0)
g_livarm_p2e            = kts.Graphic("gfx/livarm_p2e.bmp", 255,255,0)
g_livarm_p2s            = kts.Graphic("gfx/livarm_p2s.bmp", 255,255,0)
g_livarm_p2w            = kts.Graphic("gfx/livarm_p2w.bmp", 255,255,0)
g_livarm_p3n            = kts.Graphic("gfx/livarm_p3n.bmp", 255,255,0)
g_livarm_p3e            = kts.Graphic("gfx/livarm_p3e.bmp", 255,255,0)
g_livarm_p3s            = kts.Graphic("gfx/livarm_p3s.bmp", 255,255,0)
g_livarm_p3w            = kts.Graphic("gfx/livarm_p3w.bmp", 255,255,0)

g_dead_livarm_1 = kts.Graphic("gfx/dead_livarm_1.bmp", 255,255,0)
g_dead_livarm_2 = kts.Graphic("gfx/dead_livarm_2.bmp", 255,255,0)
g_dead_livarm_3 = kts.Graphic("gfx/dead_livarm_3.bmp", 255,255,0)
g_dead_livarm_4 = kts.Graphic("gfx/dead_livarm_4.bmp", 255,255,0)


-- Animation

a_living_armor = kts.Anim {
    g_livarm1n, g_livarm1e, g_livarm1s, g_livarm1w,  -- Normal
    g_livarm2n, g_livarm2e, g_livarm2s, g_livarm2w,  -- Melee backswing
    g_livarm3n, g_livarm3e, g_livarm3s, g_livarm3w,  -- Melee downswing
    g_livarm4n, g_livarm4e, g_livarm4s, g_livarm4w,  -- Parrying
    g_livarm5n, g_livarm5e, g_livarm5s, g_livarm5w,  -- Throwing backswing
    g_livarm6n, g_livarm6e, g_livarm6s, g_livarm6w,  -- Throwing follow-through
    g_livarm7n, g_livarm7e, g_livarm7s, g_livarm7w,  -- Holding crossbow
    g_livarm8n, g_livarm8e, g_livarm8s, g_livarm8w,  -- Reloading crossbow.
}

a_livarm_melee = kts.Anim {
    g_livarm_p1n, g_livarm_p1e, g_livarm_p1s, g_livarm_p1w,  -- Normal
    g_livarm_p2n, g_livarm_p2e, g_livarm_p2s, g_livarm_p2w,  -- Melee backswing
    g_livarm_p3n, g_livarm_p3e, g_livarm_p3s, g_livarm_p3w,  -- Melee downswing
    g_livarm4n,   g_livarm4e,   g_livarm4s,   g_livarm4w,    -- Just hit
}

--- Tiles

t_dead_livarm_1 = kts.Tile(C.floor & { graphic = g_dead_livarm_1, depth = -1 } )
t_dead_livarm_2 = kts.Tile(C.floor & { graphic = g_dead_livarm_2, depth = -1 } )
t_dead_livarm_3 = kts.Tile(C.floor & { graphic = g_dead_livarm_3, depth = -1 } )
t_dead_livarm_4 = kts.Tile(C.floor & { graphic = g_dead_livarm_4, depth = -1 } )

---- The monster types

i_fist = kts.ItemType {
    type = "held",

    melee_backswing_time = C.ts*2,
    melee_downswing_time = C.ts*3,
    melee_damage = C.rng_range(0, 4),
    melee_stun_time = C.rng_time_range(0, 4),
    melee_tile_damage = 0,
}

basic_living_armor = {
   type = "walking",

   -- general properties:
   health = kts.MISC_CONFIG.knight_hitpoints, -- As strong as knights are
   speed = 100, -- Knight speed
   anim = a_living_armor,
   corpse_tiles = { t_dead_livarm_1, t_dead_livarm_2, t_dead_livarm_3, t_dead_livarm_4 },
   sound = C.snd_lock, -- need a proper sound here!

   -- properties specific to walking monsters:
   weapon = i_sword,

   ai_avoid = C.all_open_pit_tiles,
   ai_fear = {C.i_wand_of_destruction},
   ai_hit = {C.i_bear_trap_open},
}

m_livarmor_sword   = kts.MonsterType( basic_living_armor & { weapon = C.i_sword } )
m_livarmor_axe     = kts.MonsterType( basic_living_armor & { weapon = C.i_axe } )
m_livarmor_hammer  = kts.MonsterType( basic_living_armor & { weapon = C.i_hammer } )
m_livarmor_fist    = kts.MonsterType( basic_living_armor & { weapon = i_fist, anim = a_livarm_melee } )
m_livarmor_undeath = kts.MonsterType( basic_living_armor & { weapon = C.i_wand_of_undeath } )

living_armors = { m_livarmor_sword,    -- 1
                  m_livarmor_axe,      -- 2
                  m_livarmor_hammer,   -- 3
                  m_livarmor_fist,     -- 4
                  m_livarmor_undeath } -- 5

-- These numbers correspond to living_armors table indexes
living_armor_chances = { 1, 1, 1, 1, 2, 2, 2, 3, 3, 3, 4, 4, 5 } 

----


